package fishrungames.bashgid.core;

import java.util.ArrayList;

import android.os.Bundle;

import fishrungames.networkutils.ImageManager;
import fishrungames.networkutils.UpdateCallbackHolder;
import fishrungames.networkutils.interfaces.NetworkActionInterface;


public class BookManager implements NetworkActionInterface
{

	public static class BookRecord
	{
		public String name;
		public String author;
		public String imageUrl;
		public Integer price;
		public String description;
		
		public BookRecord(String name, String author, String imageUrl, Integer price, String description)
		{
			this.name = name;
			this.author = author;
			this.imageUrl = imageUrl;
			this.price = price;
			this.description = description;
		}
	}

	private ArrayList<BookRecord> BookArr = new ArrayList<BookRecord>();

	public static BookManager instance = null;
	
	public static BookManager getInstance()
	{
		if (instance == null)
		{
			instance = new BookManager();
		}

		return instance;
	}
	
	public BookManager()
	{
		initBooks();
	}
	

	public ArrayList<BookRecord> getBooks()
	{
		ArrayList<BookRecord> books = new ArrayList<BookRecord>();

		synchronized(BookArr)
		{
			books.addAll(BookArr);
		}

		return books;
	}
	
	private void initBooks()
	{
		BookArr.add(new BookRecord("Репка", "", "http://www.kitap-ufa.ru/upload/iblock/079/575.jpg", 40, "Русская народная сказка..."));
		BookArr.add(new BookRecord("Уроки поэзии", "Рахматуллин С.И.", "http://www.kitap-ufa.ru/upload/iblock/6e7/012.jpg", 85, "В книгу вошли стихотворные произведения..."));
		BookArr.add(new BookRecord("Новые валенки", "Калимуллина Г.К.", "http://www.kitap-ufa.ru/upload/iblock/edd/010.jpg", 75, "Детство - самая прекрасная, веселая и интересная пора в жизни человека..."));
		BookArr.add(new BookRecord("В стране Урала", "Рафиков Б.З.", "", 90, "Эта книга настоящего мастера пера не оставит..."));
	}

	@Override
	public void InThreadAction(Bundle query, UpdateCallbackHolder callbackHolder)
	{
		
		/*
		ArrayList<String> imageToDownloadList = new ArrayList<String>();
		
		for (int i = 0; i < BookArr.size(); i++)
		{
			imageToDownloadList.add(BookArr.get(i).imageUrl);
		}
		
		Bundle innerQuery = new Bundle();
		
		innerQuery.putStringArray("imageUrlArr", imageToDownloadList.toArray(new String[imageToDownloadList.size()]));
		
		ImageManager.getInstance().InThreadAction(innerQuery, callbackHolder);	
		
		callbackHolder.OnUpdated(null);
		*/
	}
}
